**如何使用JMH**

1. 插件
```scala
addSbtPlugin("pl.project13.scala" % "sbt-jmh" % "0.4.3")
```
2. `sbt jmh:compile`
3. `sbt jmh:run`

**环境**

```
[info] # JMH version: 1.32
[info] # VM version: JDK 17.0.1, OpenJDK 64-Bit Server VM, 17.0.1+0
[info] # VM invoker: /usr/local/Cellar/openjdk/17.0.1/libexec/openjdk.jdk/Contents/Home/bin/java
```

**测试方法**

```scala
ZIO.effect {
  Try(Thread.sleep(5)).getOrElse(())
  Random.nextInt() + ""
}
```

**JMH配置**

```
@State(Scope.Thread)
@BenchmarkMode(Array(Mode.Throughput))
@OutputTimeUnit(TimeUnit.SECONDS)
@Measurement(iterations = 5)
@Warmup(iterations = 5)
@Fork(3)
```

**caffeine配置**

```
caffeine {
  maximumSize = 100
  expireAfterWriteSeconds = 60
  disabledLog = true
}
```

**redis配置**

```
redis  {
  host = "0.0.0.0"
  port = 6379
  disabledLog = true
}
```

**结果**

```
[info] Benchmark                                   (limitRandNum)   Mode  Cnt       Score       Error  Units
[info] CacheableBenchmarks.benchmarkCaffeineCache               2  thrpt   15  562046.757 ± 28099.275  ops/s
[info] CacheableBenchmarks.benchmarkNoCache                     2  thrpt   15     164.256 ±     3.277  ops/s
[info] CacheableBenchmarks.benchmarkRedisCache                  2  thrpt   15     576.943 ±   336.063  ops/s
```
